Handle really trivial case inside git-merge.

Using Linus' --trivial option, this handles really trivial case
inside git-merge itself, without using any strategy modules.

A 'really trivial case' is:

 - we are merging one branch into the current branch;
 - there is only one merge base between the branches;
 - there is no file-level merge required.

Signed-off-by: Junio C Hamano <junkio@cox.net>
diff --git a/git-merge.sh b/git-merge.sh
index 29e86c6..d12a2a9 100755
--- a/git-merge.sh
+++ b/git-merge.sh
@@ -123,10 +123,30 @@
 	dropsave
 	exit 0
 	;;
-1,*)
+1,?*"$LF"?*)
 	# We are not doing octopus and not fast forward.  Need a
 	# real merge.
 	;;
+1,*)
+	# We are not doing octopus, not fast forward, and have only
+	# one common.  See if it is really trivial.
+	echo "Trying really trivial in-index merge..."
+	git-update-index --refresh 2>/dev/null
+	if git-read-tree --trivial -m -u $common $head "$1" &&
+	   result_tree=$(git-write-tree)
+	then
+	    echo "Wonderful."
+	    result_commit=$(
+	        echo "$merge_msg" |
+	        git-commit-tree $result_tree -p HEAD -p "$1"
+	    ) || exit
+	    git-update-ref HEAD $result_commit $head
+	    summary $result_commit
+	    dropsave
+	    exit 0
+	fi
+	echo "Nope."
+	;;
 *)
 	# An octopus.  If we can reach all the remote we are up to date.
 	up_to_date=t